# -*- coding: utf-8 -*-
"""
Created on Fri May 27 11:45:58 2022

@author: Bruno
"""
import numpy as np
import matplotlib.pyplot as plt

# Positions de l'objet et de l'image

OA = - 15 # cm
OAp = 30 # cm

# Entrez les précisions

DeltaOA = 1 # cm
DeltaOAp = 3 # cm

# Entrez la fonction de composition

def focale(objet,image):
    return 1/(1/image - 1/objet)

# Entrez le nombre de simulation que vous voulez effectuer 

N = 100000

# Calculs avec une distribution de probabilité uniforme
Focale = []

for i in range(0,N):
    objet = np.random.uniform(OA-DeltaOA,OA+DeltaOA)
    image = np.random.uniform(OAp-DeltaOAp,OAp+DeltaOAp)
    Focale.append(focale(objet,image))

plt.figure(1)
plt.hist(Focale,bins = 'rice')
plt.title('Résultat du tirage aléatoire des focales après simulation')
plt.xlabel("f' (cm)")


# Calcul et affichage moyenne et écart type

moy = np.mean(Focale)
std = np.std(Focale,ddof=1)

print("Moyenne = {:.2f} cm".format(moy))
print("Ecart type = {:.2f} cm".format(std))